# -*- coding: utf-8 -*-

from qt import *
from mainform import MainForm
import re


class MainForm_Impl(MainForm):

    def __init__(self,parent = None,name = None,modal = 0,fl = 0):
        MainForm.__init__(self,parent,name,modal,fl)

    # public slot

    def init(self):
        items=[]
        items.append(QListViewItem(self.ExerciseListView,"Additions"))
        items.append(QListViewItem(self.ExerciseListView,"Divisions"))
        items.append(QListViewItem(self.ExerciseListView,"Multiplications"))
        items.append(QListViewItem(self.ExerciseListView,"Soustractions"))

        try:
            fsock = open('exercices.txt')
            try:
                dataLines = [line for line in fsock.readlines() if line[0]!='#']
            finally:
                fsock.close()
        except IOError:
            pass

        try:
            for dataLine in dataLines:
                exercice, oorq, delai, question = re.findall("^([^\\t]+)\\t+([^\\t]+)\\t+(\\d+)\\t+(\\d+)",dataLine)[0]
                op1Min, op1Max, q1, operateur, op2Min, op2Max, q2, max, q3 = re.findall("^\\[([0-9]{1,3})..([0-9]{1,3})\\](_?)([+\\-*/])\\[([0-9]{1,3})..([0-9]{1,3})\\](_?)<=([0-9]{1,3})(_?)$", oorq)[0]
                items.append(QListViewItem(items[['+', '/', '*', '-'].index(operateur)], unicode(exercice,'utf8'), oorq, delai, question))
        except NameError:
            pass



    # public slot

    def TestReponseSlot(self):
        print "MainForm_Impl.TestReponseSlot(): Not implemented yet"

    # public slot

    def StartSlot(self):
        print "MainForm_Impl.StartSlot(): Not implemented yet"

    # public slot

    def TimeOutSlot(self):
        print "MainForm_Impl.TimeOutSlot(): Not implemented yet"

    # public slot

    def SelectExerciseSlot(self):
        exercise=self.ExerciseListView.currentItem().text(1).ascii()
        if exercise:
            op1Min, op1Max, q1, operateur, op2Min, op2Max, q2, max, q3 = re.findall("^\\[([0-9]{1,3})..([0-9]{1,3})\\](_?)([+\\-*/])\\[([0-9]{1,3})..([0-9]{1,3})\\](_?)<=([0-9]{1,3})(_?)$", exercise)[0]
            self.MinOp1LineEdit.setText(op1Min)
            self.MaxOp1LineEdit.setText(op1Max)
            self.OperateurComboBox.setCurrentItem(['*', '+', '-', '/'].index(operateur))
            self.MinOp2LineEdit.setText(op2Min)
            self.MaxOp2LineEdit.setText(op2Max)
            self.ResultatMaxLineEdit.setText(max)
            self.PositionLineEdit.setText(`(q1=='_')+(q2=='_')*2+(q3=='_')*4`)
            self.CountLineEdit.setText(self.ExerciseListView.currentItem().text(3).ascii())
            self.DelaiLineEdit.setText(self.ExerciseListView.currentItem().text(2).ascii())
        else:
            operateur=self.ExerciseListView.currentItem().text(0).ascii()
            self.OperateurComboBox.setCurrentItem(['Multiplications', 'Additions', 'Soustractions', 'Divisions'].index(operateur))
    
